#!/usr/local/bin/python
import sys
sys.path=sys.path+['.','./libsvm/python']
from svm import *
from Numeric import *
import Numeric
import math
import string
import MLab

total_evaluate=0
prime_evaluate=0
function_evaluate=0

labels = []
samples = []
lastx=[-1000,-1000]
#max_index = 0

def mapdsy(l):
	return float(l.split()[0])
def mapdsx(l):
	e = l.split()[1:]
	x = {}
	for i in e:
		t = i.split(':')
		x[int(t[0])] = float(t[1])
	return x

def predict(x,norm,filename):
	global a_model
	
	error=0
	fds = open("%s.t" % filename, 'r')
	ds = fds.readlines()
	fds.close()

	testx = map(mapdsx, ds)
	testy = map(mapdsy, ds)

	evaluate(x,norm=norm)
	for i in range(len(testy)):
		resulty = a_model.predict(testx[i]);
		if resulty != testy[i]:
			error += 1;
	print error
	print len(testy)
	return (len(testy)-error)*100.0/len(testy)

def array_equal(a,b):
	a=array(a)
	b=array(b)
	return not(0 in equal(a,b))

def evaluate(x,norm=2):
	global lastx, total_evaluate

	if array_equal(lastx,x):
		return

	global svm_param,a_model,r_model
	print "running evaluate"
	print x
	print norm

	total_evaluate=total_evaluate+1
	svm_param = svm_parameter(C=math.exp(x[0]),gamma=math.exp(-1*log(2)-x[1]))
	print -1*log(2)-x[1]
	svm_param.eps=1e-6
	svm_param.cache_size=500
	if norm==2:
		svm_param.svm_type=C_SVCq
	else:
		svm_param.svm_type=C_SVC
	a_model = svm_model(problem,svm_param)
	if norm==2:
		svm_param.svm_type=R2q
	else:
		svm_param.svm_type=R2
	r_model = svm_model(problem,svm_param)
	lastx=x[:]
	
def rmboundL1(x):
	global svm_param,a_model,r_model,lastx
	print "L1 running rwbound"
	print x

	if not array_equal(lastx,x):
		print "Warnning, parameter not match!"
		evaluate(x,norm=1)

#	print ("RML1: %f " % ((r_model.rsq+1/svm_param.C)*(-2*a_model.obj)))
#	return (r_model.rsq+1/svm_param.C)*(-2*a_model.obj)
	print ("RML1: %f " % ((r_model.rsq+1/svm_param.C)*(a_model.wsq+2*a_model.cxi)))
	return (r_model.rsq+1/svm_param.C)*(a_model.wsq+2*a_model.cxi)

def rmboundL1_der(x):
	global svm_param,a_model,r_model,lastx
	print "L1 running rwbound der"
	print x

	if not array_equal(lastx,x):
		print "Warnning, parameter not match!"
		evaluate(x,norm=2)

	C=svm_param.C
	Csq=svm_param.C*svm_param.C
	Gsq=svm_param.gamma*svm_param.gamma
	Gcub=Gsq*svm_param.gamma
	Ssq=0.5/svm_param.gamma

	pc = ((-1/Csq) * (-2*a_model.obj) + (r_model.rsq+1/svm_param.C)*2*a_model.cxi/C )
	ps = r_model.partial*(-2*a_model.obj) \
	     + a_model.partial*(r_model.rsq+1/svm_param.C)
#	pc = ((-1/Csq) * (a_model.wsq+2*a_model.cxi) + (r_model.rsq+1/svm_param.C)*2*a_model.cxi/C )
#	ps = r_model.partial*(a_model.wsq+2*a_model.cxi) \
#	     + 2*a_model.partial*(r_model.rsq+1/svm_param.C)

#	totalBSV=0
#	for i in range(len(a_model.nBSV)):
#		totalBSV+=a_model.nBSV[i]
#
#	print ("nBSV=%s, pc=%s" % (totalBSV, pc))
#	
#	if totalBSV==0 and pc<0:
#		pc=0

	der=[pc*C, ps*Ssq]
	print ("RML1 DER = %f %f"%(der[0],der[1]))
	return array(der)
	
def rmboundL2(x):
	global svm_param,a_model,r_model,lastx
	print "L2 running rwbound"
	print x

	if not array_equal(lastx,x):
		print "Warnning, parameter not match!"
		evaluate(x,norm=2)


	print ("RW: %f " % (r_model.rsq*a_model.wsq))
	return r_model.rsq*a_model.wsq

def rmboundL2_der(x):
	global svm_param,a_model,r_model,max_index,lastx
	print "L2 running rwbound_der"
	print x

	if (not array_equal(lastx,x)):
		print "Warnning, parameter not match!"
		evaluate(x,norm=2)

	C=svm_param.C
	Csq=svm_param.C*svm_param.C
	Gsq=svm_param.gamma*svm_param.gamma
	Gcub=Gsq*svm_param.gamma
	Ssq=0.5/svm_param.gamma

	tmp=[]
	for i in range(len(a_model.sv_coef)):
		tmp.append(a_model.sv_coef[i][0])
	a_coef=array(tmp)
	tmp=[]
	for i in range(len(r_model.sv_coef)):
		tmp.append(r_model.sv_coef[i][0])
	r_coef=array(tmp)

	e=array([1.0]*len(r_coef))

	pc=matrixmultiply(transpose(a_coef),a_coef)*r_model.rsq/Csq+ \
	matrixmultiply(transpose(r_coef),r_coef-e)*a_model.wsq/Csq

	pg=a_model.partial*r_model.rsq+r_model.partial*a_model.wsq;

	der=[pc*C,pg*Ssq]
	print ("DER = %f %f"%(der[0],der[1]))
	return array(der)

def rmbound(x,norm=2):
	global function_evaluate

	function_evaluate+=1
	if norm==2:
		return rmboundL2(x)
	else:
		return rmboundL1(x)

def rmbound_der(x,norm=2):
	global prime_evaluate

	prime_evaluate+=1
	if norm==2:
		return rmboundL2_der(x)
	else:
		return rmboundL1_der(x)

def simple_line_search(f, fprime, norm ,xk, pk, gfk, phi0, Wolfe2=0,args=(), c1=1e-4, c2=0.9, alpha0=1):
	print xk
	# check if alpha0 is proper
	for k in range(len(xk)):
		if (xk[k]>=10.0 and pk[k]>0.0) or (xk[k]<=-10.0 and pk[k]<=0.0):
			return -1, 0, 0

	if(alpha0*pow(Numeric.dot(pk,pk),0.5)>2):
		alpha0=2/pow(Numeric.dot(pk,pk),0.5)

	for k in range(len(xk)):
		if(xk[k]+alpha0*pk[k]>10):
			alpha0=(10-xk[k])/pk[k]
		if(xk[k]+alpha0*pk[k]<-10):
			alpha0=(-10-xk[k])/pk[k]

	fc = 0
	gc = 0
	g0 = gfk
	g1 = 0
	alpha=alpha0
	derphi0 = Numeric.dot(gfk,pk)
	iteration=0

	while 1:
		evaluate(xk+alpha*pk,norm=norm)
		if Wolfe2:
			g1=apply(fprime,(xk+alpha*pk,)+args)
			gc = gc + 1

		phi1 = apply(f,(xk+alpha*pk,)+args)
		fc = fc + 1
		
		if (iteration>=20 or (phi1 <= phi0 + c1*alpha*derphi0 and (Wolfe2==0 or Numeric.dot(g1,pk)>=c2*Numeric.dot(g0,pk)))):	
			return (alpha, fc, gc)

		iteration = iteration + 1
		alpha = alpha / 2.0


def line_search_BFGS(f, fprime, norm, xk, pk, gfk, phi0, Wolfe2=0,args=(), c1=1e-4, c2=0.9, alpha0=1):
	"""Minimize over alpha, the function f(xk+alpha pk)

	Uses the interpolation algorithm (Armiijo backtracking) as suggested by
	Wright and Nocedal in 'Numerical Optimization', 1999, pg. 56-57

	Outputs: (alpha, fc, gc)
	"""


	print xk
	# check if alpha0 is proper
	for k in range(len(xk)):
		if (xk[k]>=10.0 and pk[k]>0.0) or (xk[k]<=-10.0 and pk[k]<=0.0):
			return -1, 0, 0
	
	if(alpha0*pow(Numeric.dot(pk,pk),0.5)>2):
		alpha0=2/pow(Numeric.dot(pk,pk),0.5)

	for k in range(len(xk)):
		if(xk[k]+alpha0*pk[k]>10):
			alpha0=(10-xk[k])/pk[k]
		if(xk[k]+alpha0*pk[k]<-10):
			alpha0=(-10-xk[k])/pk[k]

	fc = 0
	gc = 0
	g0 = g1 = g2 = g3 = 0

	if Wolfe2:
		g0=gfk
		print "g0Tpk: %s"%(Numeric.dot(g0,pk))

	evaluate(xk+alpha0*pk,norm=norm)
	if Wolfe2:
		g1 = apply(fprime,(xk+alpha0*pk,)+args)
		gc = gc + 1
		
	phi_a0 = apply(f,(xk+alpha0*pk,)+args)     # compute f
	fc = fc + 1
	derphi0 = Numeric.dot(gfk,pk)

	if Wolfe2:
		print "g1Tpk: %s"%(Numeric.dot(g1,pk))

	if (phi_a0 <= phi0 + c1*alpha0*derphi0 and (Wolfe2==0 or Numeric.dot(g1,pk)>=c2*Numeric.dot(g0,pk))):
		return alpha0, fc, gc

	# Otherwise compute the minimizer of a quadratic interpolant:

	alpha1 = -(derphi0) * alpha0**2 / 2.0 / (phi_a0 - phi0 - derphi0 * alpha0)
	evaluate(xk+alpha1*pk,norm=norm)
	if Wolfe2:
		g2=apply(fprime,(xk+alpha1*pk,)+args)
		gc = gc + 1

	phi_a1 = apply(f,(xk+alpha1*pk,)+args)
	fc = fc + 1

	if Wolfe2:
		print "g2Tpk: %s"%(Numeric.dot(g2,pk))
	if (phi_a1 <= phi0 + c1*alpha1*derphi0 and (Wolfe2==0 or Numeric.dot(g2,pk)>=c2*Numeric.dot(g0,pk))):
		return alpha1, fc, gc

	# Otherwise loop with cubic interpolation until we find an alpha which 
	# satifies the first Wolfe condition (since we are backtracking, we will
	# assume that the value of alpha is not too small and satisfies the second
	# condition.

	while 1:       # we are assuming pk is a descent direction
		factor = alpha0**2 * alpha1**2 * (alpha1-alpha0)
		a = alpha0**2 * (phi_a1 - phi0 - derphi0*alpha1) - \
		    alpha1**2 * (phi_a0 - phi0 - derphi0*alpha0)
		a = a / factor
		b = -alpha0**3 * (phi_a1 - phi0 - derphi0*alpha1) + \
		    alpha1**3 * (phi_a0 - phi0 - derphi0*alpha0)
		b = b / factor

		alpha2 = (-b + Numeric.sqrt(abs(b**2 - 3 * a * derphi0))) / (3.0*a)

		evaluate(xk+alpha2*pk,norm=norm)
		if Wolfe2:
			g3=apply(fprime,(xk+alpha2*pk,)+args)
			gc = gc + 1

		phi_a2 = apply(f,(xk+alpha2*pk,)+args)
		fc = fc + 1

		print "alpha = %s " % (alpha2)
		print "step = %s" %(alpha2*pk)

		if Wolfe2:
			print "g3Tpk: %s"%(Numeric.dot(g3,pk))
		if (alpha2 < 1e-6 or (phi_a2 <= phi0 + c1*alpha2*derphi0 and (Wolfe2==0 or Numeric.dot(g3,pk)>=c2*Numeric.dot(g0,pk)))):
			return alpha2, fc, gc
		print "%s > %s"%(phi_a2, phi0+c1*alpha0*derphi0)

#        if (alpha1 - alpha2) > alpha1 / 2.0 or (1 - alpha2/alpha1) < 0.96:
#            alpha2 = alpha1 / 2.0

		alpha0 = alpha1
		alpha1 = alpha2
		phi_a0 = phi_a1
		phi_a1 = phi_a2

epsilon = 1e-4

def approx_fprime(xk,f,norm,*args):
	print "ERROR:  approx currently broken"
	
	evaluate(xk,norm=norm)
	f0 = apply(f,(xk,)+args)
	grad = Numeric.zeros((len(xk),),'d')
	ei = Numeric.zeros((len(xk),),'d')
	for k in range(len(xk)):
		ei[k] = 1.0
		evaluate(xk+epsilon*ei)
		grad[k] = (apply(f,(xk+epsilon*ei,)+args) - f0)/epsilon
		ei[k] = 0.0
	return grad

def fmin_bfgs(f, x0, fprime=None, norm=2,args=(), avegtol=1e-3, maxiter=None, 
              full_output=0, disp=1,log_file=0,logfile_name='opt_path.log',line_search_method=line_search_BFGS,Wolfe2=0):
	"""Minimize a function using the BFGS algorithm.

	Description:

		Optimize the function, f, whose gradient is given by fprime using the
		quasi-Newton method of Broyden, Fletcher, Goldfarb, and Shanno (BFGS)
		See Wright, and Nocedal 'Numerical Optimization', 1999, pg. 198.

	Inputs:

		f -- the Python function or method to be minimized.
		x0 -- the initial guess for the minimizer.
		fprime -- a function to compute the gradient of f.
		args -- extra arguments to f and fprime.

	Outputs: (xopt, {fopt, func_calls, grad_calls, warnflag})

		xopt -- the minimizer of f.

		fopt -- the value of f(xopt).
		func_calls -- the number of function_calls.
		grad_calls -- the number of gradient calls.
		warnflag -- an integer warning flag:
			1 : 'Maximum number of iterations exceeded.'

	Additional Inputs:

		avegtol -- the minimum occurs when fprime(xopt)==0.  This specifies how
			close to zero the average magnitude of fprime(xopt) needs
			to be.
		maxiter -- the maximum number of iterations.
		full_output -- if non-zero then return fopt, func_calls, grad_calls,
			and warnflag in addition to xopt.
		disp -- print convergence message if non-zero.                
		"""
	if log_file:
		logfile=open(logfile_name,'w')

	app_fprime = 0
	if fprime is None:
		app_fprime = 1

	x0 = asarray(x0)

	if maxiter is None:
		maxiter = len(x0)*200
	func_calls = 0
	grad_calls = 0
	k = 0
	N = len(x0)
	gtol = N*avegtol
	I = MLab.eye(N)
	Hk = I

	if app_fprime:
		gfk = apply(approx_fprime,(x0,f)+args)
		func_calls = func_calls + len(x0) + 1
	else:
		evaluate(x0,norm=norm)
		gfk = apply(fprime,(x0,)+args)
		grad_calls = grad_calls + 1
	xk = x0
	gfk0 = gfk
	sk = [2*gtol]

	pk = -Numeric.dot(Hk,gfk)
	phi0 = apply(f,(xk,)+args)

#	if norm==1:
#		totalBSV=0
#		for i in range(len(a_model.nBSV)):
#		       	totalBSV+=a_model.nBSV[i]
#
#		print ("nBSV=%s, pc=%s" % (totalBSV, gfk[1]))
#	
#	       	if totalBSV==0 and gfk[0]<0:
#	       		pk=array([0,pk[1]])

	print "gfk = %s" % (gfk)
	print "Hk = %s" % (Hk)
	print "pk = %s" % (pk)
	
	while (Numeric.add.reduce(abs(gfk)) > gtol) and (k < maxiter):
		lastf = apply(f, (xk,)+args)
		
		if log_file:
			logfile.write("%s %s %s %s %s"%(xk, gfk, pk, apply(f,(xk,)+args),pow(Numeric.dot(gfk,gfk),0.5)))

		if Numeric.dot(gfk,gfk)/Numeric.dot(gfk0,gfk0)<1e-6:
			break

		# check norm 1 here
#		if Norm==1 and totalBSV==0 and gfk[1]*gfk[1]/Numeric.dot(gfk0,gfk0)<1e-6:
#			break
			

		if Numeric.dot(pk,gfk)>=0:
			print "ERROR: not a descent direction"
			if log_file:
				logfile.write("\nERROR: not a descent direction\n")
				logfile.flush()
			pk=-pk

		alpha_k, fc, gc = apply(line_search_method,(f,fprime,norm, xk,pk,gfk,phi0,Wolfe2,args))
		
		if log_file:
			logfile.write(" fc = %s \n"%(fc))
			logfile.flush()

		print "alpha_k = %s " % (alpha_k)

		if alpha_k<0:
			logfile.write(" parameter exceed bound!\n")
			logfile.flush();
			break

		func_calls = func_calls + fc
		xkp1 = xk + alpha_k * pk
		sk = xkp1 - xk
		xk = xkp1

		if app_fprime:
			gfkp1 = apply(approx_fprime,(xkp1,f)+args)
			func_calls = func_calls + gc + len(x0) + 1
		else:
			gfkp1 = apply(fprime,(xkp1,)+args)
			grad_calls = grad_calls + gc + 1

		yk = gfkp1 - gfk
		k = k + 1

		if lastf-apply(f, (xkp1,)+args) < 1e-6:
			print "Warning: Function value increase < 1e-6!"
			if log_file:
				logfile.write("\nWarning: Function value increase %s < 1e-6!\n"%(lastf-apply(f,(xkp1,)+args)))
				logfile.flush()
			break
			

		if Numeric.dot(yk,sk)==0 :
			print "ERROR: Numerical Error Detected!"
			if log_file:
				logfile.write("\nERROR: Numerical Error Detected!\n")
				logfile.flush()
			break

		
		rhok = 1 / Numeric.dot(yk,sk)
		if Wolfe2==1 and rhok<0:
			print "ERROR: check Wolfe2 but ykTsk still <0"
			if log_file:
				logfile.write("\nERROR: check Wolfe2 but ykTsk still <0\n")
				logfile.flush()
			break

		if rhok>0:
			A1 = I - sk[:,Numeric.NewAxis] * yk[Numeric.NewAxis,:] * rhok
			A2 = I - yk[:,Numeric.NewAxis] * sk[Numeric.NewAxis,:] * rhok
			Hk = Numeric.dot(A1,Numeric.dot(Hk,A2)) + rhok * sk[:,Numeric.NewAxis] \
						       * sk[Numeric.NewAxis,:]
		gfk = gfkp1

		pk = -Numeric.dot(Hk,gfk)
		phi0 = apply(f,(xk,)+args)

		func_calls = func_calls + 1


#		print "orig pk = %s" % (pk)
#		
#		if norm==1:
#			totalBSV=0
#			for i in range(len(a_model.nBSV)):
#				totalBSV+=a_model.nBSV[i]
#
#			print ("nBSV=%s, pc=%s" % (totalBSV, gfk[1]))
#	
#			if totalBSV==0 and gfk[0]<0:
#				pk=array([0,pk[1]])

		print "gfk = %s" % (gfk)
		print "Hk = %s" % (Hk)
		print "pk = %s" % (pk)


	if disp or full_output:
		fval = apply(f,(xk,)+args)
	if k >= maxiter:
		warnflag = 1
		if disp:
			print "Warning: Maximum number of iterations has been exceeded"
			print "         Current function value: %f" % fval
			print "         Iterations: %d" % k
			print "         Function evaluations: %d" % func_calls
			print "         Gradient evaluations: %d" % grad_calls
	else:
		warnflag = 0
		if disp:
			print "Optimization terminated successfully."
			print "         Current function value: %f" % fval
			print "         Iterations: %d" % k
			print "         Function evaluations: %d" % func_calls
			print "         Gradient evaluations: %d" % grad_calls

	if log_file:
		global total_evaluate, prime_evaluate, dataname
		logfile.write( "\n         Current function value: %f\n" % fval)
		logfile.write( "         Iterations: %d\n" % k)
		logfile.write( "         Function evaluations: %d\n" % func_calls)
		logfile.write( "         Gradient evaluations: %d\n" % grad_calls)
		logfile.write( "         Total Evaluate: %s, Function Evaluate: %s, Prime Evaluate: %s\n" % (total_evaluate, function_evaluate, prime_evaluate))

		if norm==1:
			tmp=[]
			for i in range(len(a_model.sv_coef)):
				tmp.append(a_model.sv_coef[i][0])
			a_coef=array(tmp)
			a_coef=abs(a_coef)
			for i in range(len(a_coef)):
				if a_coef[i]<0:
					print "ERROR!"
			
			xk[0]=math.log(max(abs(a_coef)))

		logfile.write( "         Optimal at %s\n" % xk )

	logfile.close()
	if full_output:
		return xk, fval, func_calls, grad_calls, warnflag
	else:        
		return xk


if len(sys.argv) < 2:
	print "Usage: model_select.py dataset logfile_name initC initGamma 1 0 1"
	sys.exit()

dataname=sys.argv[1];
f = open(sys.argv[1])
line = f.readline()
max_index=0
while line:
	global max_index
	elems = string.split(line)
	sample = {}
	for e in elems[1:]:
		points = string.split(e, ":")
		sample[int(points[0])] = float(points[1])
		if int(points[0]) > max_index:
			max_index = int(points[0])
	labels.append(float(elems[0]))
	samples.append(sample)
	line = f.readline()
f.close()
print "%d samples loaded." % (len(samples))
problem = svm_problem(labels, samples);

#evaluate([-1.8988676,-0.62793457],1)
#print a_model.partial
#print a_model.wsq
#print r_model.partial
#print r_model.rsq

# model_select.py data logfile initC initS Simple:1 Wolfe1:0 norm

InitC=string.atof(sys.argv[3])
InitSigma=string.atof(sys.argv[4])

#print approx_fprime(array([-1.71,0.52]),rmboundL1,norm=1)

if string.atoi(sys.argv[5]):
	fmin_bfgs(rmbound,[InitC,InitSigma],fprime=rmbound_der,log_file=1,logfile_name=sys.argv[2],Wolfe2=string.atoi(sys.argv[6]),line_search_method=simple_line_search,norm=string.atoi(sys.argv[7]),args=(string.atoi(sys.argv[7]),))	
else:
	fmin_bfgs(rmbound,[InitC,InitSigma],fprime=rmbound_der,log_file=1,logfile_name=sys.argv[2],Wolfe2=string.atoi(sys.argv[6]),line_search_method=line_search_BFGS,norm=string.atoi(sys.argv[7]),args=(string.atoi(sys.argv[7]),))

